//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dctupdate.h"
#include "dmdict.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDictUpdate *DictUpdate;
//---------------------------------------------------------------------------
__fastcall TDictUpdate::TDictUpdate(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TDictUpdate::TDictUpdate(TComponent* Owner, int oper, int iwrd)
        : TForm(Owner)
{
        operation = oper;
        iWordNumber = iwrd;
}

void __fastcall TDictUpdate::wbt_OKClick(TObject *Sender)
{
        ModalResult = mrNone;
        if(operation == 0) {
                if( weWord->Text.Trim().IsEmpty()) {
                        Application->MessageBoxA("Word cannot be empty!", "Data error", MB_OK);
                        FocusControl(weWord);
                        return;
                }
                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add("INSERT INTO DICTIONARY(cWord, bDefinition) VALUES (:cWord, :bDefinition)");

                IBQuery1->ParamByName("cWord")->AsString = weWord->Text;
                IBQuery1->ParamByName("bDefinition")->AsString = wmDefinition->Text;
                IBQuery1->ExecSQL();
        }
        else
        if(operation == 1) {

                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add("UPDATE DICTIONARY SET bDefinition = :bDefinition WHERE iWordNumber = :iWordNumber");
                IBQuery1->ParamByName("bDefinition")->AsString = wmDefinition->Text;
                IBQuery1->ParamByName("iWordNumber")->AsInteger = iWordNumber;
                IBQuery1->ExecSQL();

        }
        else
        if(operation == 2) {
                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add("DELETE FROM DICTIONARY WHERE iWordNumber = :iWordNumber");
                IBQuery1->ParamByName("iWordNumber")->AsInteger = iWordNumber;
                IBQuery1->ExecSQL();

        }
        ModalResult = mrOk;        
}
//---------------------------------------------------------------------------


void __fastcall TDictUpdate::FormShow(TObject *Sender)
{
        switch(operation) {
                case 0:
                        this->Caption = String("Dictionary: New entry");
                        this->FocusControl(weWord);
                        break;
                case 1:
                        this->Caption = String("Dictionary: Update entry");
                        this->weWord->Enabled = false;
                        this->FocusControl(wmDefinition);
                        break;
                case 2:
                        this->Caption = String("Dictionary: Delete entry");
                        this->weWord->Enabled = false;
                        this->wmDefinition->ReadOnly = true;
                        this->FocusControl(wbt_Cancel);
                        break;
        }

        if(operation > 0) {
                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add("SELECT cWord, bDefinition FROM DICTIONARY WHERE iWordNumber = :iWordNumber");
                IBQuery1->ParamByName("iWordNumber")->AsInteger = iWordNumber;
                IBQuery1->Open();
                weWord->Text = IBQuery1->FieldByName("cWord")->AsString;
                wmDefinition->Text = IBQuery1->FieldByName("bDefinition")->AsString;
        }

}
//---------------------------------------------------------------------------

