//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dict.h"
#include "dmdict.h"
#include "dctupdate.h"
#include "dictimport.h"
#include "fileimpexp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TDictionary *Dictionary;
//---------------------------------------------------------------------------
__fastcall TDictionary::TDictionary(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------



void __fastcall TDictionary::weWordSearchChange(TObject *Sender)
{
        int iWordNumber;
        TLocateOptions LocOps;
        Variant v;

        String sSQL;

//        DMDictionary->QueryWords(weWordSearch->Text);

        sSQL = " SELECT FIRST 1 iWordNumber" \
                      " FROM Dictionary " \
                      " WHERE cWord_UPPER = :param " \
                      " ORDER BY cWord_UPPER";
        IBFindWord->Close();
        IBFindWord->SQL->Clear();
        IBFindWord->SQL->Add(sSQL);
        IBFindWord->ParamByName("param")->AsString = weWordSearch->Text.UpperCase() ;
        IBFindWord->ExecQuery();
        iWordNumber = IBFindWord->Fields[0]->AsInteger;

        if(iWordNumber <= 0) {
                sSQL = " SELECT FIRST 1 iWordNumber" \
                              " FROM Dictionary " \
                              " WHERE cWord_UPPER LIKE :param " \
                              " ORDER BY cWord_UPPER";
                IBFindWord->Close();
                IBFindWord->SQL->Clear();
                IBFindWord->SQL->Add(sSQL);
                IBFindWord->ParamByName("param")->AsString = weWordSearch->Text.UpperCase() + "%" ;
                IBFindWord->ExecQuery();

                iWordNumber = IBFindWord->Fields[0]->AsInteger;

        }

        if(iWordNumber > 0) {
                LocOps.Clear();
                v = Variant(iWordNumber);
                DataSource1->DataSet->Locate("iWordNumber", v, LocOps);
        }

}
//---------------------------------------------------------------------------



void __fastcall TDictionary::InsertRecordExecute(TObject *Sender)
{
        int iWordNumber;
        TLocateOptions LocOps;
        Variant v;

        DictUpdate = new TDictUpdate(this, 0, 0);
        DictUpdate->Enabled = true;

        if( DictUpdate->ShowModal() == mrOk) {
                DMDictionary->IBGeneratorQuery->Close();
                DMDictionary->IBGeneratorQuery->ExecQuery();
                iWordNumber = DMDictionary->IBGeneratorQuery->Fields[0]->AsInteger;

                DMDictionary->QueryWords("", wtbEmpty->Checked);

                DBGrid1->Refresh();

                LocOps.Clear();
                v = Variant(iWordNumber);
                DataSource1->DataSet->Locate("iWordNumber", v, LocOps);

        }
        delete DictUpdate;
}
//---------------------------------------------------------------------------

void __fastcall TDictionary::UpdateRecordExecute(TObject *Sender)
{
        TLocateOptions LocOps;
        Variant v;
        int iWordNumber;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;

        iWordNumber = DBGrid1->DataSource->DataSet->FieldByName("iWordNumber")->AsInteger;
        DictUpdate = new TDictUpdate(this, 1, iWordNumber);

        LocOps.Clear();
        if( DictUpdate->ShowModal() == mrOk) {
                DMDictionary->QueryWords("", wtbEmpty->Checked); // refresh data
                v = Variant(iWordNumber);
                DataSource1->DataSet->Locate("iWordNumber", v, LocOps);
        }
        delete DictUpdate;
}
//---------------------------------------------------------------------------

void __fastcall TDictionary::DeleteRecordExecute(TObject *Sender)
{
        TLocateOptions LocOps;
        Variant v;
        int iWordNumber, iAnotherWord;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iWordNumber = DBGrid1->DataSource->DataSet->FieldByName("iWordNumber")->AsInteger;

        if(DataSource1->DataSet->RecordCount > 1) {
                DataSource1->DataSet->Prior();
                iAnotherWord = DataSource1->DataSet->FieldByName("iWordNumber")->AsInteger;
                // iWordNumber points to first record ?
                if(iAnotherWord == iWordNumber) {
                        DataSource1->DataSet->Next();
                        iAnotherWord = DataSource1->DataSet->FieldByName("iWordNumber")->AsInteger;
                        DataSource1->DataSet->Prior(); // return to current word
                }
                else DataSource1->DataSet->Next(); // return to current word
        }

        DictUpdate = new TDictUpdate(this, 2, iWordNumber);
        DictUpdate->Enabled = true;
        if( DictUpdate->ShowModal() == mrOk) {
                DMDictionary->QueryWords("", wtbEmpty->Checked);
                iWordNumber = iAnotherWord;

                LocOps.Clear();
                v = Variant(iWordNumber);
                DataSource1->DataSet->Locate("iWordNumber", v, LocOps);
                countWords();
        }

        delete DictUpdate;
}
//---------------------------------------------------------------------------






void __fastcall TDictionary::FormShow(TObject *Sender)
{
        int i;
        DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);

        countWords();
}
//---------------------------------------------------------------------------



void __fastcall TDictionary::wbtFileClick(TObject *Sender)
{
        DictFileImpExp = new TDictFileImpExp(this);
        DictFileImpExp->Enabled = true;

        if( DictFileImpExp->ShowModal() == mrOk) {
                DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
                countWords();
        }

        delete DictFileImpExp;

}
//---------------------------------------------------------------------------

void __fastcall TDictionary::wbtDeleteClick(TObject *Sender)
{
                int i = MessageDlg("Do you really want to DELETE ALL WORDS?",
                                   mtConfirmation, TMsgDlgButtons() << mbNo << mbYes, 0);

                if(i == mrYes) {
                        String sSQL = " DELETE FROM Dictionary";
                        IBFindWord->Close();
                        IBFindWord->SQL->Clear();
                        IBFindWord->SQL->Add(sSQL);
                        IBFindWord->ExecQuery();
                        DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
                        countWords();
                }

}
//---------------------------------------------------------------------------

void __fastcall TDictionary::wbtDupClick(TObject *Sender)
{
        String sSQL = " DELETE FROM Dictionary A WHERE "\
                      "    NOT SINGULAR(SELECT 1 FROM DICTIONARY B" \
                      "                 WHERE B.cWORD_UPPER = A.cWORD_UPPER" \
                      "                   AND B.bDefinition = A.bDefinition)";

        IBFindWord->Close();
        IBFindWord->SQL->Clear();
        IBFindWord->SQL->Add(sSQL);
        IBFindWord->ExecQuery();
        DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
        countWords();

}
//---------------------------------------------------------------------------

void __fastcall TDictionary::countWords(void) {
        int i;

        String sSQL;

        if(wtbEmpty->Checked) {
                sSQL = " SELECT COUNT(*) FROM Dictionary WHERE bDefinition IS NULL";
        }
        else {
                sSQL = " SELECT COUNT(*) FROM Dictionary ";
        }
        IBFindWord->Close();
        IBFindWord->SQL->Clear();
        IBFindWord->SQL->Add(sSQL);
        IBFindWord->ExecQuery();
        i = IBFindWord->Fields[0]->AsInteger;

        Label1->Caption = String(i) + " words";

}
void __fastcall TDictionary::wbtDictClick(TObject *Sender)
{
        DictImportC = new TDictImportC(this);
        DictImportC->Enabled = true;

        if( DictImportC->ShowModal() == mrOk) {
                DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
                countWords();
        }

        delete DictImportC;
}
//---------------------------------------------------------------------------

void __fastcall TDictionary::FormCreate(TObject *Sender)
{
        String dbName;
        dbName = "dict.fdb";
        DMDictionary->OpenDatabase(dbName);
}

//---------------------------------------------------------------------------

void __fastcall TDictionary::OpenQuery()
{
        DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
        countWords();
}

void __fastcall TDictionary::wtbEmptyClick(TObject *Sender)
{
        DMDictionary->QueryWords(weWordSearch->Text, wtbEmpty->Checked);
        countWords();
}
//---------------------------------------------------------------------------

