//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "dmdict.h"
#include "dictimport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

class Base64 {
        char conversionTable[128];
public:
        Base64() {
                String alfabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
                for(int i = 0; i < alfabet.Length(); i++) {
                        conversionTable[ alfabet.SubString(i + 1, 1).c_str()[0] ] = i;
                }
        }
        unsigned long decodeB64(char *s) {
                /*
                        this piece of code is based on b64_decode (LGPL)
                                from base64.c from dictd-1.5.5 package
                */
                unsigned long v = 0;
                int i;
                int offset = 0;
                int len = strlen(s);

                for(i = len - 1; i>= 0; i--) {
                        int tmp = conversionTable[ (unsigned char)s[i] ];
                        v |= tmp << offset;
                        offset+=6;
                }
                return v;
        }
};


TDictImportC *DictImportC;
//---------------------------------------------------------------------------
__fastcall TDictImportC::TDictImportC(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TDictImportC::FileOpen1BeforeExecute(TObject *Sender)
{
/* */

}
//---------------------------------------------------------------------------

void __fastcall TDictImportC::FileOpen2BeforeExecute(TObject *Sender)
{
/* */
}
//---------------------------------------------------------------------------


void __fastcall TDictImportC::wbt_DefinitionsClick(TObject *Sender)
{
        if(OpenDialog1->Execute())
                Edit1->Text = OpenDialog1->FileName;        
}
//---------------------------------------------------------------------------

void __fastcall TDictImportC::wbt_IndexClick(TObject *Sender)
{
        if(OpenDialog2->Execute())
                Edit2->Text = OpenDialog2->FileName;

}
//---------------------------------------------------------------------------

void __fastcall TDictImportC::wbt_OKClick(TObject *Sender)
{
        Base64 decoder;
        int iIndexFile, iDefFile;
        int iIndexLength, iDefLength;
        char *pszBuffer, *pszDef, *pszProcDef;
        char *pszIEntries[3];
        int iScanPos, iBufferPos, iBufferType, iPos;
        unsigned long offset, size, lDefBuffer;
        String bDefinition;

        this->ModalResult = mrNone;
        try {
                iIndexFile = FileOpen(Edit2->Text, fmOpenRead);
                if(iIndexFile < 0) {
                        Application->MessageBoxA("Cannot read index file", "Error", MB_OK);
                        return;
                }
                iIndexLength = FileSeek(iIndexFile, 0, 2);
                FileSeek(iIndexFile, 0, 0);
                pszBuffer = new char[iIndexLength + 1];
                iIndexLength = FileRead(iIndexFile, pszBuffer, iIndexLength);
                FileClose(iIndexFile);
        }
        catch (...) {
                if(pszBuffer != NULL)
                        delete []pszBuffer;
                Application->MessageBoxA("Cannot read index file", "Error", MB_OK);
                return;
        }

        try {
                iDefFile = FileOpen(Edit1->Text, fmOpenRead);
                if(iDefFile < 0) {
                        if(pszBuffer != NULL)
                                delete []pszBuffer;

                        Application->MessageBoxA("Cannot read file with definitions", "Error", MB_OK);
                        return;
                }
                iDefLength = FileSeek(iDefFile, 0, 2);
        }
        catch (...) {
                if(pszBuffer != NULL)
                        delete []pszBuffer;

                Application->MessageBoxA("Cannot read file with definitions", "Error", MB_OK);
                return;
        }

        /*
                scan index line and decode base 64, skip lines beginning with 00-
                if position + size < iDefLengt
                        read expression and definition and write to database
        */
        iScanPos = 0;

        pszIEntries[0] = new char[51]; // let's limit definition to 50 chars + ending 0
        pszIEntries[1] = new char[10]; // position to 10 (Base64)
        pszIEntries[2] = new char[10]; // length to 10 (Base64)

        iBufferType = 0;
        iBufferPos = 0;
        lDefBuffer = 1000;
        pszDef = new char[lDefBuffer];
        pszProcDef = new char[lDefBuffer * 2];

        ProgressBar1->Max = iIndexLength;
        ProgressBar1->Position = 0;
        ProgressBar1->Visible = true;
try {
        while(1) {
                if( pszBuffer[iScanPos] == '\n' ) {
                        if(iScanPos % 200 == 0) {
                                ProgressBar1->Position = iScanPos;
                                IBQuery1->Transaction->CommitRetaining();

                        }
                        if(iBufferType == 2 ) {
                                pszIEntries[iBufferType][iBufferPos] = 0;

                                if(pszIEntries[0][0] != '0' && pszIEntries[0][0] != 0) {
                                // decode position and size
                                        offset = decoder.decodeB64(pszIEntries[1]) + strlen(pszIEntries[0]);
                                        size   = decoder.decodeB64(pszIEntries[2]) - strlen(pszIEntries[0]);
                                        if(offset + size > iDefLength || size > 8000) {
                                               iBufferType = 0;
                                               iBufferPos = 0;
                                               continue;
                                        }

                                        if(size > lDefBuffer) {
                                                delete []pszDef;
                                                delete []pszProcDef;
                                                lDefBuffer = size * 2;
                                                pszDef = new char[lDefBuffer];
                                                pszProcDef = new char[lDefBuffer * 2];
                                        }



                                        FileSeek(iDefFile, (int)offset, 0);
                                        size = FileRead(iDefFile, pszDef, size);
                                        iPos = -1;
                                        for(unsigned long i=0;i<size;i++) {
                                                if(iPos <0 ) {
                                                        if(isspace(pszDef[i])) continue;
                                                        else iPos = 0;
                                                }
                                                if(pszDef[i] == '\r') continue;
                                                if(pszDef[i] == '\n') {
                                                        pszProcDef[iPos++] = '\r';
                                                }
                                                pszProcDef[iPos++] = pszDef[i];
                                        }
                                        pszProcDef[iPos] = 0;


                                        // write to database
                                        if(size > 0 ) {
                                                IBQuery1->Close();
                                                IBQuery1->SQL->Clear();
                                                IBQuery1->SQL->Add("INSERT INTO DICTIONARY(cWord, bDefinition) VALUES (:cWord, :bDefinition)");

                                                IBQuery1->ParamByName("cWord")->AsString = Utf8ToAnsi( String(pszIEntries[0]) );
                                                IBQuery1->ParamByName("bDefinition")->AsString = Utf8ToAnsi( String(pszProcDef) );
                                                IBQuery1->ExecQuery();
                                        }

                                }


                        }
                        iBufferType = 0;
                        iBufferPos = 0;
                }
                else if(pszBuffer[iScanPos] == '\t') {
                        if(iBufferType < 3) pszIEntries[iBufferType][iBufferPos] = 0;
                        iBufferType++;
                        iBufferPos = 0;
                     }
                     else {
                        if(iBufferType == 0) {
                                pszIEntries[iBufferType][iBufferPos] = pszBuffer[iScanPos];
                                iBufferPos++;
                                if(iBufferPos == 51) iBufferPos = 50;
                        }
                        else
                                if(iBufferType < 3) {
                                        pszIEntries[iBufferType][iBufferPos] = pszBuffer[iScanPos];
                                        iBufferPos++;
                                        if(iBufferPos == 10) iBufferPos = 9;
                                }
                     }


                iScanPos++;

                if(iScanPos == iIndexLength) break;
        }
} catch (Exception *exception) {
        Application->ShowException(exception);
        
        delete []pszProcDef;
        delete []pszDef;
        delete []pszIEntries[0];
        delete []pszIEntries[1];
        delete []pszIEntries[2];
        if(pszBuffer != NULL)
                  delete []pszBuffer;

        FileClose(iDefFile);

        ProgressBar1->Visible = false;
        return;
}

        delete []pszProcDef;
        delete []pszDef;
        delete []pszIEntries[0];
        delete []pszIEntries[1];
        delete []pszIEntries[2];
        if(pszBuffer != NULL)
                  delete []pszBuffer;

        FileClose(iDefFile);

        ProgressBar1->Visible = false;

        this->ModalResult = mrOk;
}
//---------------------------------------------------------------------------


