//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dmdict.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDMDictionary *DMDictionary;
//---------------------------------------------------------------------------
__fastcall TDMDictionary::TDMDictionary(TComponent* Owner)
        : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------

bool TDMDictionary::CloseDatabase() {
        if(IBDbDictionary->Connected) {
                IBWordsQuery->Active = false;
                IBDbDictionary->Close();
        }
        return true;
}

bool TDMDictionary::QueryWords(String sWordMask, bool emptyOnly) {
        if(!IBDbDictionary->Connected ) return false;

        String sSQL;
        if(emptyOnly) {
               sSQL = " SELECT cWord,iWordNumber,bDefinition, cWord_Upper" \
                      " FROM Dictionary " \
                      " WHERE cWord_UPPER LIKE :param AND bDefinition IS NULL" \
                      " ORDER BY cWord_UPPER ";
        }
        else   sSQL = " SELECT cWord,iWordNumber,bDefinition, cWord_Upper" \
                      " FROM Dictionary " \
                      " WHERE cWord_UPPER LIKE :param " \
                      " ORDER BY cWord_UPPER ";

        IBWordsQuery->SQL->Clear();
        IBWordsQuery->SQL->Add(sSQL);
        IBWordsQuery->ParamByName("param")->AsString = sWordMask.UpperCase() + "%" ;

        IBWordsQuery->Open();
        }

bool TDMDictionary::OpenDatabase(String dbName) {

        if(IBDbDictionary->Connected) {
                if( IBDbDictionary->DatabaseName == dbName) return true;
                IBDbDictionary->Close();
        }

        IBDbDictionary->DatabaseName = dbName;

        String sCreateStr[] = {
                "CREATE TABLE Dictionary ( " \
                "    iWordNumber INTEGER NOT NULL PRIMARY KEY," \
                "    iType SMALLINT, " \
                "    cWord varchar(50), " \
                "    cWord_UPPER varchar(50), " \
                "    bDefinition BLOB SUB_TYPE TEXT); ",
                "CREATE INDEX Dictionary_ix1 ON Dictionary (iWordNumber);",
                "CREATE INDEX Dictionary_ix2 ON Dictionary(cWord_UPPER);",
                "CREATE GENERATOR gen_iWordNumber;",
                "CREATE TRIGGER create_Dictionary FOR Dictionary" \
                "    ACTIVE BEFORE INSERT POSITION 0" \
                "    AS" \
                "    BEGIN" \
                "        IF (NEW.iWordNumber IS NULL) THEN" \
                "            NEW.iWordNumber = GEN_ID(gen_iWordNumber, 1);" \
                "        NEW.cWord_UPPER = UPPER( NEW.cWord );" \
                "    END;",
                "GRANT ALL ON Dictionary TO PUBLIC;"
                 };

        try {
                IBDbDictionary->Params->Clear();
                IBDbDictionary->Params->Add("user_name=sysdba");
                IBDbDictionary->Params->Add("password=sysdba");

                IBDbDictionary->Open();
        }
        catch (EIBInterBaseError &exception) {
                try {
                        IBDbDictionary->Params->Clear();
                        IBDbDictionary->Params->Add("user \"sysdba\"");
                        IBDbDictionary->Params->Add("password \"sysdba\"");

                        IBDbDictionary->CreateDatabase();

                        for(int i=0; i < 6; i++) {
                                IBCreateTables->SQL->Clear();
                                IBCreateTables->SQL->Add(sCreateStr[i]);
                                IBCreateTables->Transaction->Active = true;
                                IBCreateTables->ExecQuery();
                                IBCreateTables->Transaction->Commit();
                        }

                        IBCreateTables->Transaction->Active = false;

                        }
                catch (Exception &exception)
                {
                        Application->ShowException(&exception);


                }

        }
        catch (Exception &exception)
        {
                Application->ShowException(&exception);
        }

        IBDbDictionary->CheckActive();

        if(IBWordsQuery->SQL->Count > 0 ) IBWordsQuery->Active = true;
        return(IBDbDictionary->Connected);
}






