//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "dmuser.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDMUserData *DMUserData;
//---------------------------------------------------------------------------
__fastcall TDMUserData::TDMUserData(TComponent* Owner)
        : TDataModule(Owner)
{
}

bool TDMUserData::OpenDatabase(String dbName) {

        if(IBDbUser->Connected) {
                if( IBDbUser->DatabaseName == dbName) return true;
                IBDbUser->Close();
        }

        IBDbUser->DatabaseName = dbName;

        String sCreateStr[] = {
                "CREATE TABLE Files ( " \
                "    iFileNumber    INTEGER NOT NULL PRIMARY KEY," \
                "    cName          VARCHAR(30), "\
                "    cFileName      VARCHAR(256), " \
                "    iSectionType   INTEGER, " \
                "    iSectionSize   INTEGER, " \
                "    iWords         INTEGER, " \
                "    iSections      INTEGER);", \
                "CREATE GENERATOR gen_iFileNumber;",
                "CREATE TRIGGER create_Files FOR Files" \
                "    ACTIVE BEFORE INSERT POSITION 0" \
                "    AS" \
                "    BEGIN" \
                "        IF (NEW.iFileNumber IS NULL) THEN" \
                "            NEW.iFileNumber = GEN_ID(gen_iFileNumber, 1);" \
                "    END;",
                "CREATE TABLE Sections ( " \
                "    iFileNumber    INTEGER,   " \
                "    iSectionId     INTEGER,   " \
                "    iFileSeek      INTEGER,   " \
                "    iNewWords      INTEGER ); ",
                "CREATE INDEX Sections_ix1 ON Sections (iFileNumber, iSectionId);",
                "CREATE INDEX Sections_ix2 ON Sections (iFileNumber, iFileSeek);",
                "CREATE TABLE Words ( " \
                "    iWordId        INTEGER,"\
                "    iFileNumber    INTEGER,"\
                "    iSectionId     INTEGER," \
                "    cWord          VARCHAR(50)," \
                "    cWord_UPPER    VARCHAR(50)," \
                "    iFileSeek      INTEGER); ",
                "CREATE INDEX Words_ix1 ON Words (iFileNumber, iWordId);",
                "CREATE INDEX Words_ix2 ON Words (iFileNumber, cWord_UPPER);",
                "CREATE INDEX Words_ix3 ON Words (iFileNumber, iFileSeek);",                                
                "CREATE GENERATOR gen_iWordId;",
                "CREATE TRIGGER create_Words FOR Words" \
                "    ACTIVE BEFORE INSERT POSITION 0" \
                "    AS" \
                "    BEGIN" \
                "        IF (NEW.iWordID IS NULL) THEN" \
                "            NEW.iWordId = GEN_ID(gen_iWordId, 1);" \
                "        NEW.cWord_UPPER = UPPER( NEW.cWord );" \
                "    END;",
                "ALTER TABLE Sections " \
                "       ADD CONSTRAINT FK_Files_1" \
                "       FOREIGN KEY(iFileNumber) REFERENCES Files(iFileNumber)" \
                "       ON UPDATE CASCADE ON DELETE CASCADE;",
                "ALTER TABLE Words " \
                "       ADD CONSTRAINT FK_Files_2" \
                "       FOREIGN KEY(iFileNumber) REFERENCES Files(iFileNumber)" \
                "       ON UPDATE CASCADE ON DELETE CASCADE;",
                "GRANT ALL ON Files TO PUBLIC;",
                "GRANT ALL ON Sections TO PUBLIC;",
                "GRANT ALL ON Words TO PUBLIC;"
                 };

        try {
                IBDbUser->Params->Clear();
                IBDbUser->Params->Add("user_name=sysdba");
                IBDbUser->Params->Add("password=sysdba");

                IBDbUser->Open();
        }
        catch (EIBInterBaseError &exception) {
                try {
                        IBDbUser->Params->Clear();
                        IBDbUser->Params->Add("user \"sysdba\"");
                        IBDbUser->Params->Add("password \"sysdba\"");

                        IBDbUser->CreateDatabase();

                        for(int i=0; i < 17; i++) {
                                IBCreateTables->SQL->Clear();
                                IBCreateTables->SQL->Add(sCreateStr[i]);
                                IBCreateTables->Transaction->Active = true;
                                IBCreateTables->ExecQuery();
                                IBCreateTables->Transaction->Commit();
                        }

                        IBCreateTables->Transaction->Active = false;


                        }
                catch (Exception &exception)
                {
                        Application->ShowException(&exception);


                }

        }
        catch (Exception *exception)
        {
                Application->ShowException(exception);
        }

        IBDbUser->CheckActive();

//        if(IBWordsQuery->SQL->Count > 0 ) IBWordsQuery->Active = true;
        return(IBDbUser->Connected);
}


//---------------------------------------------------------------------------

