//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "exportsm.h"
#include "dmuser.h"
#include "dmdict.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TExportToSM *ExportToSM;
//---------------------------------------------------------------------------
__fastcall TExportToSM::TExportToSM(TComponent* Owner)
        : TForm(Owner)
{
}

_fastcall TExportToSM::TExportToSM(TComponent* Owner, int iFileNmbr, int iSections, String sName)
        : TForm(Owner)
{
        weTo->Text = String(iSections);
        iFileNumber = iFileNmbr;
        weFileName->Text = GetCurrentDir() + "\\" + sName + ".txt";
}

//---------------------------------------------------------------------------
void __fastcall TExportToSM::wbtExportClick(TObject *Sender)
{
        if(SaveDialog1->Execute())
                weFileName->Text = SaveDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TExportToSM::BitBtn1Click(TObject *Sender)
{
        int iFile, from, to, type, i;
        String cWord, cWord_UPPER, bDefinition;
        ModalResult = mrNone;

        try {
                from = StrToInt(weFrom->Text);
                to = StrToInt(weTo->Text);

                if(from > to) {
                        Application->MessageBoxA("From cannot be greater than to!", "Data error", MB_OK);
                        FocusControl(weFrom);
                        return;
                }
                type = RadioGroup1->ItemIndex;

                if(weFileName->Text.IsEmpty()) {
                        Application->MessageBoxA("File name cannot be empty!", "Data error", MB_OK);
                        FocusControl(weFileName);
                        return;
                }

                iFile = FileCreate(weFileName->Text);
                if(iFile < 0) {
						throw EFOpenError("Cannot write to file: " + weFileName->Text + "!", 0);
                }

                IBQueryWords->Close();
                IBQueryWords->SQL->Clear();
                IBQueryWords->SQL->Add("SELECT cWord, cWord_UPPER "\
                                       "FROM Words "\
                                       "WHERE iFileNumber = :iFileNumber "\
                                       "  AND iSectionId >= :iFrom "\
                                       "  AND iSectionId <= :iTo ");
                IBQueryWords->ParamByName("iFileNumber")->AsInteger = iFileNumber;
                IBQueryWords->ParamByName("iFrom")->AsInteger = from;
                IBQueryWords->ParamByName("iTo")->AsInteger = to;
                IBQueryWords->Open();


                while(!IBQueryWords->Eof) {
                        cWord       = IBQueryWords->FieldByName("cWord")->AsString;
                        cWord_UPPER = IBQueryWords->FieldByName("cWord_UPPER")->AsString;

                        IBQueryDict->SQL->Clear();
                        IBQueryDict->SQL->Add("SELECT FIRST 1 bDefinition "\
                                              "FROM Dictionary "\
                                              "WHERE cWORD_UPPER = :cWord_UPPER ");
                        IBQueryDict->ParamByName("cWord_UPPER")->AsString = cWord_UPPER;
                        IBQueryDict->Open();
                        
                        if(IBQueryDict->RecordCount > 0) {
                                bDefinition = IBQueryDict->FieldByName("bDefinition")->AsString;
                        }
                        else bDefinition = "";

                        if(!CheckBox1->Checked || bDefinition != "") {
                                if(type == 0) {
                                        cWord = "Q: " + cWord + "\r\n";
                                        FileWrite(iFile, cWord.c_str(), cWord.Length());
                                        bDefinition = StringReplace(bDefinition, "\n", " ", TReplaceFlags() << rfReplaceAll);
                                        bDefinition = StringReplace(bDefinition, "\r", "", TReplaceFlags() << rfReplaceAll);

                                        bDefinition = "A: " + bDefinition + "\r\n\r\n";
                                        FileWrite(iFile, bDefinition.c_str(), bDefinition.Length());
                                }
                                else {
                                        bDefinition = StringReplace(bDefinition, "\n", " ", TReplaceFlags() << rfReplaceAll);
                                        bDefinition = StringReplace(bDefinition, "\r", "", TReplaceFlags() << rfReplaceAll);
                                        bDefinition = "Q: " + bDefinition + "\r\n";
                                        FileWrite(iFile, bDefinition.c_str(), bDefinition.Length());
                                        cWord = "A: " + cWord + "\r\n\r\n";
                                        FileWrite(iFile, cWord.c_str(), cWord.Length());
                                }
                        }


                        IBQueryWords->Next();
                }
                FileClose(iFile);

                i = IBQueryWords->RowsAffected;
                Application->MessageBoxA(String(i).c_str(), "nn", MB_OK);

        } catch(Exception &exception) {
                        if(iFile > 0) FileClose(iFile);
                        Application->ShowException(&exception);
                        return;

        }
        ModalResult = mrOk;
}
//---------------------------------------------------------------------------
