//---------------------------------------------------------------------------

#include <vcl.h>
#include "dmdict.h"
#pragma hdrstop

#include "fileimpexp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDictFileImpExp *DictFileImpExp;
//---------------------------------------------------------------------------
__fastcall TDictFileImpExp::TDictFileImpExp(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDictFileImpExp::wbtFileClick(TObject *Sender)
{
        if(OpenDialog1->Execute())
                Edit1->Text = OpenDialog1->FileName;        

}
//---------------------------------------------------------------------------
void __fastcall TDictFileImpExp::weDelimiterExit(TObject *Sender)
{
     if( weDelimiter->Text.Trim() == "") {
        Application->MessageBox("Empty delimiter!", "Warning", MB_OK);
     }

}
//---------------------------------------------------------------------------
void __fastcall TDictFileImpExp::wbt_OKClick(TObject *Sender)
{
        if(wrsImport->Checked) ImportFile();
        else ExportFile();
}
//---------------------------------------------------------------------------

void __fastcall TDictFileImpExp::ImportFile() {
        int iImportFile, iFileLength, iBufferPos, iBufferLength, iScanType, iScanPos, iPosition;
        char *pszBuffer, cWord[2048], bDefinition[2048];

        this->ModalResult = mrNone;
        try {
                iImportFile = FileOpen(Edit1->Text, fmOpenRead | fmShareDenyNone);
                if(iImportFile < 0) {
                        Application->MessageBoxA("Cannot read file", "Error", MB_OK);
                        return;
                }
                iFileLength = FileSeek(iImportFile, 0, 2);
                FileSeek(iImportFile, 0, 0);
                pszBuffer = new char[19065];
                iBufferLength = 0;
                iScanPos = 0;
                iScanType = 0;
                iPosition = 0;
                ProgressBar1->Max = iFileLength;
                ProgressBar1->Position = 0;
                ProgressBar1->Visible = true;
                if(weDelimiter->Text.Length() == 0) weDelimiter->Text = ' '; 
                while(1) {
                        iBufferLength = FileRead(iImportFile, pszBuffer, 19065);
                        if(iBufferLength <= 0) break;

                        for(iBufferPos = 0;iBufferPos < iBufferLength;iBufferPos ++) {
                                iPosition++;

                                if(iScanType == 0) {
                                        if(pszBuffer[iBufferPos] == '\r') continue;
                                        if(pszBuffer[iBufferPos] == '\n') {
                                                iScanPos = 0;
                                                continue;
                                        }

                                        if(pszBuffer[iBufferPos] == weDelimiter->Text.c_str()[0]) {

                                                cWord[iScanPos] = 0;
                                                iScanPos = 0;
                                                iScanType = 1;
                                                continue;
                                        }

                                        if(iScanPos < sizeof(cWord) - 1) {
                                                cWord[iScanPos++] = pszBuffer[iBufferPos];
                                                continue;
                                        }
                                        cWord[iScanPos] = 0;
                                }
                                else {
                                        if(pszBuffer[iBufferPos] == '\r') continue;
                                        if(pszBuffer[iBufferPos] == '\n') {
                                                bDefinition[iScanPos] = 0;
                                                iScanPos = 0;
                                                iScanType = 0;
                                                ProgressBar1->Position = iPosition;

                                                IBQuery1->Close();
                                                IBQuery1->SQL->Clear();
                                                IBQuery1->SQL->Add("INSERT INTO DICTIONARY(cWord, bDefinition) VALUES (:cWord, :bDefinition)");

                                                if(wrsWordDef->Checked) {
                                                        cWord[49] = 0;
                                                        IBQuery1->ParamByName("cWord")->AsString = cWord;
                                                        IBQuery1->ParamByName("bDefinition")->AsString = bDefinition;
                                                }
                                                else {
                                                        bDefinition[49] = 0;
                                                        IBQuery1->ParamByName("cWord")->AsString = bDefinition;
                                                        IBQuery1->ParamByName("bDefinition")->AsString = cWord;

                                                }
                                                IBQuery1->ExecQuery();


                                                continue;
                                        }
                                        if(iScanPos < sizeof(bDefinition) - 1) {
                                                bDefinition[iScanPos++] = pszBuffer[iBufferPos];
										}


                                }

                        }

                }

        }
        catch (Exception *exception) {
                if(pszBuffer != NULL)
                        delete []pszBuffer;
                FileClose(iImportFile);
                Application->ShowException(exception);
                ProgressBar1->Visible = false;
                return;
        }


        if(pszBuffer != NULL)
                  delete []pszBuffer;

        FileClose(iImportFile);

        ProgressBar1->Visible = false;

        this->ModalResult = mrOk;

}




void __fastcall TDictFileImpExp::ExportFile() {
        int iExportFile;
        String cWord, bDefinition;

        this->ModalResult = mrNone;
        try {
                if(Edit1->Text.IsEmpty()) {
                        Application->MessageBoxA("File name cannot be empty!", "Data error", MB_OK);
                        FocusControl(Edit1);
                        return;
                }

                iExportFile = FileCreate(Edit1->Text);
                if(iExportFile < 0) {
						throw EFOpenError("Cannot write to file: " + Edit1->Text + "!", 0);
                }


                ProgressBar1->Position = 0;

                if(weDelimiter->Text.Length() == 0) weDelimiter->Text = ' ';

                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add(" SELECT COUNT(*) FROM Dictionary ");
                IBQuery1->ExecQuery();

                ProgressBar1->Max = IBQuery1->Fields[0]->AsInteger;
                ProgressBar1->Visible = true;

                IBQuery1->Close();
                IBQuery1->SQL->Clear();
                IBQuery1->SQL->Add("SELECT cWord, bDefinition "\
                                   "FROM Dictionary "\
                                   "ORDER BY cWord_UPPER");
                IBQuery1->ExecQuery();

                while(!IBQuery1->Eof) {
                        if(wrsWordDef->Checked) {
                               cWord       = IBQuery1->FieldByName("cWord")->AsString;
                                bDefinition = IBQuery1->FieldByName("bDefinition")->AsString;
                        }
                        else
                        {
                               cWord       = IBQuery1->FieldByName("cWord")->AsString;
                               bDefinition = IBQuery1->FieldByName("bDefinition")->AsString;
                        }

                        if( !cWord.IsEmpty() &&  (!bDefinition.IsEmpty() || !CheckBox1->Checked)) {
                                FileWrite(iExportFile, cWord.c_str(), cWord.Length());
                                FileWrite(iExportFile, weDelimiter->Text.c_str(), weDelimiter->Text.Length());
                                FileWrite(iExportFile, bDefinition.c_str(), bDefinition.Length());
                                FileWrite(iExportFile, "\r\n", 2);
                        }
                        IBQuery1->Next();

                        ProgressBar1->Position ++;
                }
                FileClose(iExportFile);
        }
        catch (Exception *exception) {
                FileClose(iExportFile);
                Application->ShowException(exception);
                ProgressBar1->Visible = false;
                return;
        }

        ProgressBar1->Visible = false;
        this->ModalResult = mrOk;

}
void __fastcall TDictFileImpExp::wrsExportClick(TObject *Sender)
{
        CheckBox1->Visible = true;        
}
//---------------------------------------------------------------------------

void __fastcall TDictFileImpExp::wrsImportClick(TObject *Sender)
{
        CheckBox1->Visible = false;
}
//---------------------------------------------------------------------------

