//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "files.h"
#include "dmuser.h"
#include "filupdate.h"
#include "exportsm.h"
#include "practise.h"
#include "wps.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFilesF *FilesF;
//---------------------------------------------------------------------------
__fastcall TFilesF::TFilesF(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFilesF::FormShow(TObject *Sender)
{
   IBQuery1->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TFilesF::wbtAddClick(TObject *Sender)
{
        int iFileNumber;
        TLocateOptions LocOps;

        String sSQL = "SELECT GEN_ID(gen_iFileNumber,0) FROM RDB$DATABASE";
        Variant v;

        FileUpdate = new TFileUpdate(this, 0, 0);

        if( FileUpdate->ShowModal() == mrOk) {
                IBSQL1->Close();
                IBSQL1->SQL->Clear();
                IBSQL1->SQL->Add(sSQL);
                IBSQL1->Transaction->Active = true;
                IBSQL1->ExecQuery();
                IBSQL1->Transaction->Active = false;
                iFileNumber = IBSQL1->Fields[0]->AsInteger;

                IBQuery1->Close();
                IBQuery1->Open();

                LocOps.Clear();
                v = Variant(iFileNumber);
                DataSource1->DataSet->Locate("iFileNumber", v, LocOps);

        }
        delete FileUpdate;
}
//---------------------------------------------------------------------------

void __fastcall TFilesF::wbtUpdateClick(TObject *Sender)
{
        TLocateOptions LocOps;
        Variant v;
        int iFileNumber;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;
        FileUpdate = new TFileUpdate(this, 1, iFileNumber);

        LocOps.Clear();
        if( FileUpdate->ShowModal() == mrOk) {
                IBQuery1->Close();
                IBQuery1->Open();
                v = Variant(iFileNumber);
                DataSource1->DataSet->Locate("iFileNumber", v, LocOps);
        }
        delete FileUpdate;
}
//---------------------------------------------------------------------------

void __fastcall TFilesF::wbtDeleteClick(TObject *Sender)
{
        TLocateOptions LocOps;
        Variant v;
        int iFileNumber, iAnotherFile;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;

        if(DataSource1->DataSet->RecordCount > 1) {
                DataSource1->DataSet->Prior();
                iAnotherFile = DataSource1->DataSet->FieldByName("iFileNumber")->AsInteger;
                // iFileNumber points to first record ?
                if(iAnotherFile == iFileNumber) {
                        DataSource1->DataSet->Next();
                        iAnotherFile = DataSource1->DataSet->FieldByName("iFileNumber")->AsInteger;
                        DataSource1->DataSet->Prior(); // return to current word
                }
                else DataSource1->DataSet->Next(); // return to current word
        }

        FileUpdate = new TFileUpdate(this, 2, iFileNumber);
        FileUpdate->Enabled = true;
        if( FileUpdate->ShowModal() == mrOk) {
                IBQuery1->Close();
                IBQuery1->Open();
                iFileNumber = iAnotherFile;

                LocOps.Clear();
                v = Variant(iFileNumber);
                DataSource1->DataSet->Locate("iFileNumber", v, LocOps);
        }

        delete FileUpdate;
}
//---------------------------------------------------------------------------


void __fastcall TFilesF::wbtExportSMClick(TObject *Sender)
{
        int iFileNumber, iSections;
        String sName;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;
        iSections = DBGrid1->DataSource->DataSet->FieldByName("Sections")->AsInteger;
        sName = DBGrid1->DataSource->DataSet->FieldByName("Name")->AsString;


        ExportToSM = new TExportToSM(this, iFileNumber, iSections, sName );

        ExportToSM->ShowModal();


        delete ExportToSM;


}
//---------------------------------------------------------------------------

void __fastcall TFilesF::wbtPractiseClick(TObject *Sender)
{
        int iFileNumber, iSections;


        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;
        iSections = DBGrid1->DataSource->DataSet->FieldByName("Sections")->AsInteger;

        PractiseF = new TPractiseF(this, iFileNumber, iSections );

        PractiseF->ShowModal();


        delete PractiseF;

}
//---------------------------------------------------------------------------


void __fastcall TFilesF::wbtWordsPerSectionClick(TObject *Sender)
{
        int iFileNumber, iSections;
        String sName;

        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;
        iSections = DBGrid1->DataSource->DataSet->FieldByName("Sections")->AsInteger;
        sName = DBGrid1->DataSource->DataSet->FieldByName("Name")->AsString;

        WordsPerSection = new TWordsPerSection(this, iFileNumber, iSections, sName );

        WordsPerSection->ShowModal();


        delete WordsPerSection;

}
//---------------------------------------------------------------------------


void __fastcall TFilesF::FormCreate(TObject *Sender)
{
        String dbName;
        dbName = "user.fdb";
        DMUserData->OpenDatabase(dbName);
}
//---------------------------------------------------------------------------

void __fastcall TFilesF::CreateWordsWithoutDefinitions()
{
        int iFileNumber;
        String cWord, cWord_UPPER;
        if(DBGrid1->DataSource->DataSet->IsEmpty()) return;
        int i = MessageDlg("For each word that does not have a corresponding "
                           "entry in dictionary such entry will be created."
                           "Are you sure you want to do this ?",
                           mtConfirmation, TMsgDlgButtons() << mbNo << mbYes, 0);


        iFileNumber = DBGrid1->DataSource->DataSet->FieldByName("iFileNumber")->AsInteger;

        if(i == mrYes) {
            try {
                IBQueryWords->Close();
                IBQueryWords->SQL->Clear();
                IBQueryWords->SQL->Add("SELECT cWord, cWord_UPPER "\
                                       "FROM Words "\
                                       "WHERE iFileNumber = :iFileNumber ");
                IBQueryWords->ParamByName("iFileNumber")->AsInteger = iFileNumber;
                IBQueryWords->Open();

                while(!IBQueryWords->Eof) {
                        cWord       = IBQueryWords->FieldByName("cWord")->AsString;
                        cWord_UPPER = IBQueryWords->FieldByName("cWord_UPPER")->AsString;

                        IBQueryDict->SQL->Clear();
                        IBQueryDict->SQL->Add("SELECT 1 "\
                                              "FROM Dictionary "\
                                              "WHERE cWORD_UPPER = :cWord_UPPER ");
                        IBQueryDict->ParamByName("cWord_UPPER")->AsString = cWord_UPPER;
                        IBQueryDict->Open();

                        if(IBQueryDict->RecordCount <= 0) {
                                IBQueryDict->SQL->Clear();
                                IBQueryDict->SQL->Add("INSERT INTO DICTIONARY(cWord) VALUES (:cWord)");
                                IBQueryDict->ParamByName("cWord")->AsString = cWord;
                                IBQueryDict->ExecSQL();
                        }

                        IBQueryWords->Next();
                }
            }
            catch(Exception *exception) {
                IBQueryDict->Transaction->Rollback();
                Application->ShowException(exception);
            }
        }
}
