//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "practise.h"
#include "dmuser.h"
#include "dmdict.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPractiseF *PractiseF;
//---------------------------------------------------------------------------
__fastcall TPractiseF::TPractiseF(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TPractiseF::TPractiseF(TComponent* Owner, int iFileNmbr, int iSections)
        : TForm(Owner)
{
        iFileNumber = iFileNmbr;
        weTo->Text = String(iSections);
}

void __fastcall TPractiseF::wbtOkClick(TObject *Sender)
{
        int from, to;
        String cWord;
        ModalResult = mrNone;
        try {
                from = StrToInt(weFrom->Text);
                to = StrToInt(weTo->Text);
                if(from > to) {
                        Application->MessageBoxA("From cannot be greater than to!", "Data error", MB_OK);
                        FocusControl(weFrom);
                        return;
                }

                IBQueryWords->Close();
                IBQueryWords->SQL->Clear();
                IBQueryWords->SQL->Add("SELECT cWord, cWord_UPPER "\
                                       "FROM Words "\
                                       "WHERE iFileNumber = :iFileNumber "\
                                       "  AND iSectionId >= :iFrom "\
                                       "  AND iSectionId <= :iTo ");
                IBQueryWords->ParamByName("iFileNumber")->AsInteger = iFileNumber;
                IBQueryWords->ParamByName("iFrom")->AsInteger = from;
                IBQueryWords->ParamByName("iTo")->AsInteger = to;
                IBQueryWords->Open();
                while(!IBQueryWords->Eof) {
                        cWord       = IBQueryWords->FieldByName("cWord")->AsString;

                        IBQueryDict->SQL->Clear();
                        IBQueryDict->SQL->Add("SELECT FIRST 1 bDefinition "\
                                              "FROM Dictionary "\
                                              "WHERE cWORD_UPPER = :cWord_UPPER ");
                        IBQueryDict->ParamByName("cWord_UPPER")->AsString = cWord.UpperCase();
                        IBQueryDict->Open();

                        if(IBQueryDict->RecordCount > 0) {
                                words.push(cWord);
                        }
                        IBQueryWords->Next();

                }

                IBQueryWords->Close();
                if(words.empty()) {
                        Application->MessageBoxA("Selected sections do not contain any new words with entries in dictionary.", "Data error", MB_OK);
                        FocusControl(weTo);
                        return;
                }

                iWordsCount = words.size();
                GetNextWord();

                this->GroupBox1->Visible = false;
                this->GroupBox2->Visible = true;
                wbtCancel->Visible = false;
                wbtOk->Visible = false;


        }
        catch (Exception &exception) {
                Application->ShowException(&exception);
                return;
        }


}
//---------------------------------------------------------------------------

void __fastcall TPractiseF::wbtIKnowClick(TObject *Sender)
{
   if(words.empty()) {
        wbtStop->Visible = false;
        wbtDontKnow->Visible = false;
        wbtIKnow->Visible = false;

        wbtOk->Visible = true;
        wbtCancel->Visible = true;
        GroupBox2->Visible = false;
        GroupBox1->Visible = true;
        Application->MessageBoxA("Congratulations, this was the last word from selected sections", "Information", MB_OK);
        FocusControl(weFrom);
        StatusBar1->SimpleText = "";        
        return;
   }

   GetNextWord();
}
//---------------------------------------------------------------------------

void __fastcall TPractiseF::wbtDontKnowClick(TObject *Sender)
{
        words.push(String(weWord->Lines->Text));
        GetNextWord();
}
//---------------------------------------------------------------------------

void TPractiseF::GetNextWord()
{
        String cWord;

        weWord->Visible = true;
        weDefinition->Visible = false;
        wbtDontKnow->Visible = false;
        wbtIKnow->Visible = false;
        wbtAnswer->Visible = true;
        wbtStop->Visible = true;

        weDefinition->Lines->Clear();
        cWord = words.front();
        words.pop();

        weWord->Lines->Text = cWord;
        IBQueryDict->SQL->Clear();
        IBQueryDict->SQL->Add("SELECT FIRST 1 bDefinition "\
                              "FROM Dictionary "\
                              "WHERE cWORD_UPPER = :cWord_UPPER ");
        IBQueryDict->ParamByName("cWord_UPPER")->AsString = cWord.UpperCase();
        IBQueryDict->Open();


        if(IBQueryDict->RecordCount > 0) {
                 weDefinition->Lines->Add( IBQueryDict->FieldByName("bDefinition")->AsString );
        }

        this->FocusControl(wbtAnswer);
        StatusBar1->SimpleText = String(words.size() + 1) + "/" + String(iWordsCount);
}

void __fastcall TPractiseF::wbtAnswerClick(TObject *Sender)
{
        wbtAnswer->Visible = false;
        wbtIKnow->Visible = true;
        wbtDontKnow->Visible = true;
        weDefinition->Visible = true;
        FocusControl(wbtIKnow);
}
//---------------------------------------------------------------------------

